diff --git a/NEWS b/NEWS
index fdcd7e7..b6c2f73 100644
--- a/NEWS
+++ b/NEWS
@@ -34,6 +34,10 @@ Version 2.25
 
 * The fesetexcept function from TS 18661-1:2014 is added to libm.
 
+* The <sys/quota.h> header now includes the <linux/quota.h> header.  Support
+  for the Linux quota interface which predates kernel version 2.4.22 has
+  been removed.
+
 Security related changes:
 
   On ARM EABI (32-bit), generating a backtrace for execution contexts which
diff --git a/sysdeps/unix/sysv/linux/Makefile b/sysdeps/unix/sysv/linux/Makefile
index f0b052d..9a0423e 100644
--- a/sysdeps/unix/sysv/linux/Makefile
+++ b/sysdeps/unix/sysv/linux/Makefile
@@ -42,7 +42,7 @@ sysdep_headers += sys/mount.h sys/acct.h sys/sysctl.h \
 		  bits/socket_type.h bits/syscall.h bits/sysctl.h \
 		  bits/mman-linux.h
 
-tests += tst-clone tst-clone2 tst-fanotify tst-personality
+tests += tst-clone tst-clone2 tst-fanotify tst-personality tst-quota
 
 # Generate the list of SYS_* macros for the system calls (__NR_* macros).
 
diff --git a/sysdeps/unix/sysv/linux/sys/quota.h b/sysdeps/unix/sysv/linux/sys/quota.h
index 316febe..94b2ee9 100644
--- a/sysdeps/unix/sysv/linux/sys/quota.h
+++ b/sysdeps/unix/sysv/linux/sys/quota.h
@@ -1,6 +1,22 @@
 /* This just represents the non-kernel parts of <linux/quota.h>.
- *
- * here's the corresponding copyright:
+   Copyright (C) 1998-2016 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+/*
  * Copyright (c) 1982, 1986 Regents of the University of California.
  * All rights reserved.
  *
@@ -38,13 +54,7 @@
 #include <features.h>
 #include <sys/types.h>
 
-/*
- * Select between different incompatible quota versions.
- * Default to the version used by Linux kernel version 2.4.22
- * or later.  */
-#ifndef _LINUX_QUOTA_VERSION
-# define _LINUX_QUOTA_VERSION 2
-#endif
+#include <linux/quota.h>
 
 /*
  * Convert diskblocks to blocks and the other way around.
@@ -57,7 +67,7 @@
  * Convert count of filesystem blocks to diskquota blocks, meant
  * for filesystems where i_blksize != BLOCK_SIZE
  */
-#define fs_to_dq_blocks(num, blksize) (((num) * (blksize)) / BLOCK_SIZE)
+#define fs_to_dq_blocks(num, blksize) (((num) * (blksize)) / 1024)
 
 /*
  * Definitions for disk quotas imposed on the average user
@@ -71,113 +81,33 @@
 #define MAX_IQ_TIME  604800	/* (7*24*60*60) 1 week */
 #define MAX_DQ_TIME  604800	/* (7*24*60*60) 1 week */
 
-#define MAXQUOTAS 2
-#define USRQUOTA  0		/* element used for user quotas */
-#define GRPQUOTA  1		/* element used for group quotas */
-
-/*
- * Definitions for the default names of the quotas files.
- */
-#define INITQFNAMES { \
-   "user",      /* USRQUOTA */ \
-   "group",   /* GRPQUOTA */ \
-   "undefined", \
-};
-
 #define QUOTAFILENAME "quota"
 #define QUOTAGROUP "staff"
 
 #define NR_DQHASH 43          /* Just an arbitrary number any suggestions ? */
 #define NR_DQUOTS 256         /* Number of quotas active at one time */
 
-/*
- * Command definitions for the 'quotactl' system call.
- * The commands are broken into a main command defined below
- * and a subcommand that is used to convey the type of
- * quota that is being manipulated (see above).
- */
-#define SUBCMDMASK  0x00ff
-#define SUBCMDSHIFT 8
-#define QCMD(cmd, type)  (((cmd) << SUBCMDSHIFT) | ((type) & SUBCMDMASK))
-
-#if _LINUX_QUOTA_VERSION < 2
-# define Q_QUOTAON  0x0100	/* enable quotas */
-# define Q_QUOTAOFF 0x0200	/* disable quotas */
-# define Q_GETQUOTA 0x0300	/* get limits and usage */
-# define Q_SETQUOTA 0x0400	/* set limits and usage */
-# define Q_SETUSE   0x0500	/* set usage */
-# define Q_SYNC     0x0600	/* sync disk copy of a filesystems quotas */
-# define Q_SETQLIM  0x0700	/* set limits */
-# define Q_GETSTATS 0x0800	/* get collected stats */
-# define Q_RSQUASH  0x1000	/* set root_squash option */
-#else
-# define Q_SYNC     0x800001	/* sync disk copy of a filesystems quotas */
-# define Q_QUOTAON  0x800002	/* turn quotas on */
-# define Q_QUOTAOFF 0x800003	/* turn quotas off */
-# define Q_GETFMT   0x800004	/* get quota format used on given filesystem */
-# define Q_GETINFO  0x800005	/* get information about quota files */
-# define Q_SETINFO  0x800006	/* set information about quota files */
-# define Q_GETQUOTA 0x800007	/* get user quota structure */
-# define Q_SETQUOTA 0x800008	/* set user quota structure */
-# define Q_GETNEXTQUOTA 0x800009	/* get disk limits and usage >= ID */
-#endif
-
-/*
- * The following structure defines the format of the disk quota file
- * (as it appears on disk) - the file is an array of these structures
- * indexed by user or group number.
- */
-#if _LINUX_QUOTA_VERSION < 2
+/* Old name for struct if_dqblk.  */
 struct dqblk
   {
-    u_int32_t dqb_bhardlimit;	/* absolute limit on disk blks alloc */
-    u_int32_t dqb_bsoftlimit;	/* preferred limit on disk blks */
-    u_int32_t dqb_curblocks;	/* current block count */
-    u_int32_t dqb_ihardlimit;	/* maximum # allocated inodes */
-    u_int32_t dqb_isoftlimit;	/* preferred inode limit */
-    u_int32_t dqb_curinodes;	/* current # allocated inodes */
-    time_t dqb_btime;		/* time limit for excessive disk use */
-    time_t dqb_itime;		/* time limit for excessive files */
+    __uint64_t dqb_bhardlimit;	/* absolute limit on disk quota blocks alloc */
+    __uint64_t dqb_bsoftlimit;	/* preferred limit on disk quota blocks */
+    __uint64_t dqb_curspace;	/* current quota block count */
+    __uint64_t dqb_ihardlimit;	/* maximum # allocated inodes */
+    __uint64_t dqb_isoftlimit;	/* preferred inode limit */
+    __uint64_t dqb_curinodes;	/* current # allocated inodes */
+    __uint64_t dqb_btime;	/* time limit for excessive disk use */
+    __uint64_t dqb_itime;	/* time limit for excessive files */
+    __uint32_t dqb_valid;	/* bitmask of QIF_* constants */
   };
-#else
-
-/* Flags that indicate which fields in dqblk structure are valid.  */
-#define QIF_BLIMITS	1
-#define QIF_SPACE	2
-#define QIF_ILIMITS	4
-#define QIF_INODES	8
-#define QIF_BTIME	16
-#define QIF_ITIME	32
-#define QIF_LIMITS	(QIF_BLIMITS | QIF_ILIMITS)
-#define QIF_USAGE	(QIF_SPACE | QIF_INODES)
-#define QIF_TIMES	(QIF_BTIME | QIF_ITIME)
-#define QIF_ALL		(QIF_LIMITS | QIF_USAGE | QIF_TIMES)
-
-struct dqblk
-  {
-    u_int64_t dqb_bhardlimit;	/* absolute limit on disk quota blocks alloc */
-    u_int64_t dqb_bsoftlimit;	/* preferred limit on disk quota blocks */
-    u_int64_t dqb_curspace;	/* current quota block count */
-    u_int64_t dqb_ihardlimit;	/* maximum # allocated inodes */
-    u_int64_t dqb_isoftlimit;	/* preferred inode limit */
-    u_int64_t dqb_curinodes;	/* current # allocated inodes */
-    u_int64_t dqb_btime;	/* time limit for excessive disk use */
-    u_int64_t dqb_itime;	/* time limit for excessive files */
-    u_int32_t dqb_valid;	/* bitmask of QIF_* constants */
-  };
-#endif
 
 /*
  * Shorthand notation.
  */
 #define	dq_bhardlimit	dq_dqb.dqb_bhardlimit
 #define	dq_bsoftlimit	dq_dqb.dqb_bsoftlimit
-#if _LINUX_QUOTA_VERSION < 2
-# define dq_curblocks	dq_dqb.dqb_curblocks
-#else
-# define dq_curspace	dq_dqb.dqb_curspace
-# define dq_valid	dq_dqb.dqb_valid
-#endif
+#define dq_curspace	dq_dqb.dqb_curspace
+#define dq_valid	dq_dqb.dqb_valid
 #define	dq_ihardlimit	dq_dqb.dqb_ihardlimit
 #define	dq_isoftlimit	dq_dqb.dqb_isoftlimit
 #define	dq_curinodes	dq_dqb.dqb_curinodes
@@ -186,35 +116,14 @@ struct dqblk
 
 #define dqoff(UID)      ((loff_t)((UID) * sizeof (struct dqblk)))
 
-#if _LINUX_QUOTA_VERSION < 2
-struct dqstats
-  {
-    u_int32_t lookups;
-    u_int32_t drops;
-    u_int32_t reads;
-    u_int32_t writes;
-    u_int32_t cache_hits;
-    u_int32_t pages_allocated;
-    u_int32_t allocated_dquots;
-    u_int32_t free_dquots;
-    u_int32_t syncs;
-  };
-#else
-
-/* Flags that indicate which fields in dqinfo structure are valid.  */
-# define IIF_BGRACE	1
-# define IIF_IGRACE	2
-# define IIF_FLAGS	4
-# define IIF_ALL	(IIF_BGRACE | IIF_IGRACE | IIF_FLAGS)
-
+/* Old name for struct if_dqinfo.  */
 struct dqinfo
   {
-    u_int64_t dqi_bgrace;
-    u_int64_t dqi_igrace;
-    u_int32_t dqi_flags;
-    u_int32_t dqi_valid;
+    __uint64_t dqi_bgrace;
+    __uint64_t dqi_igrace;
+    __uint32_t dqi_flags;
+    __uint32_t dqi_valid;
   };
-#endif
 
 __BEGIN_DECLS
 